%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function [K,R,I]=assm_sys(edof,K,Ke,R,Re,I,Ie)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% assemble local element contributions to global stiffness and force
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% input:  edof  = [ elem X1 Y1 X2 ... Y4 ] ... element incidence matrix
%         Ke    = [ 8 x 8 ]                ... element tangent  Ke 
%         Re    = [ 8 x 1 ]                ... element residual Re
%         Ie    = [ 4 x 1 ]                ... element int var  Ie
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% output: K     = [ ndof x ndof ]          ... global tangent   K
%         R     = [ ndof x 1    ]          ... global residual  R
%         I     = [ nel  x 4    ]          ... global int var   I
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
[nie,n]=size(edof);

I(edof(:,1),:)=Ie(:);

t=edof(:,2:n);
for i = 1:nie
  K(t(i,:),t(i,:)) = K(t(i,:),t(i,:))+Ke;
  R(t(i,:))         =R(t(i,:))       +Re;
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
