%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function plot_int(e_spa,i_var,is);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% plot of internal variables on spatial configuration %%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% input:  e_spa = [ nel, x1 y1 x2 ... y4 ] ... spatial coordinates
%         i_var = [ nel, 4 ]               ... internal variables
%         nel   = [ 1 ]                    ... number of elements
%         is    = [ 1 ]                    ... time step
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
figure(1)   
clf
set(gcf, 'renderer', 'zbuffer');
hold on;
colormap('default')
[nel,sizen] = size(i_var);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% plot internal variable in its representative area for all elements
for ie = 1:nel
  x   = e_spa(ie, 1:2:end);          y   = e_spa(ie, 2:2:end);
  
  x(5)=(x(1)+x(2))/2;                y(5)=(y(1)+y(2))/2;
  x(6)=(x(2)+x(3))/2;                y(6)=(y(2)+y(3))/2;
  x(7)=(x(3)+x(4))/2;                y(7)=(y(3)+y(4))/2;
  x(8)=(x(4)+x(1))/2;                y(8)=(y(4)+y(1))/2;
  x(9)=(x(1)+x(2)+x(3)+x(4))/4;      y(9)=(y(1)+y(2)+y(3)+y(4))/4;

  xip(1,:)=[x(1),x(5),x(9),x(8)];    yip(1,:)=[y(1),y(5),y(9),y(8)]; 
  xip(2,:)=[x(5),x(2),x(6),x(9)];    yip(2,:)=[y(5),y(2),y(6),y(9)]; 
  xip(3,:)=[x(8),x(9),x(7),x(4)];    yip(3,:)=[y(8),y(9),y(7),y(4)];  
  xip(4,:)=[x(9),x(6),x(3),x(7)];    yip(4,:)=[y(9),y(6),y(3),y(7)]; 

  for ip = 1:4			               
    [var]  = i_var(ie,ip);   
    hh= fill(xip(ip,:)', yip(ip,:)', var');
    set(hh, 'EdgeColor', 'black');
  end
end
% plot internal variable in its representative area for all elements
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

caxis([-1 1])
colorbar
axis equal;
axis([-0.1, 2.1, -0.4, 1.1]);
axis off;
   
print('-dtiff', '-r100', ...
      ['plot_', num2str(is,['%',num2str(5),'.',num2str(5),'d'])])
hold off;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
